Subject: Re: [PATCH net-next] rocker: check for BRIDGE_FLAGS_SELF in bridge setlink handler

From: roopa <[email-masked]>
Date: Thu, 05 Mar 2015 07:09:01 -0800

On 3/5/15, 7:01 AM, roopa wrote:
> On 3/5/15, 12:36 AM, Jiri Pirko wrote:
>> Wed, Mar 04, 2015 at 01:15:29AM CET, [email-masked] wrote:
>>> From: Roopa Prabhu <[email-masked]>
>>>
>>> With the recent addition of the NETIF_F_HW_SWITCH_OFFLOAD flag
>>> on rocker ports, the second command (bridge link set) below will 
>>> turn off
>>> learning in the rocker hw (Scott/Jiri, need some confirmation from
>>> you that this is indeed a problem and if the below patch is ok).
>>>
>>> ip link set dev swp1 master br0
>>> bridge link set dev swp1 learning off master
>>> bridge link set dev swp1 learning_sync on self
>>>
>>> This patch fixes rocker to ignore learning setting when 'master'
>>> is set. This makes it possible to set/unset learning in kernel and 
>>> bridge
>>> driver independently.
>>>
>>> The below command will continue to set learning on in both kernel 
>>> and rocker
>>> hw:
>>> bridge link set dev swp1 learning on
>>>
>>> Signed-off-by: Roopa Prabhu <[email-masked]>
>>> ---
>>> drivers/net/ethernet/rocker/rocker.c |    3 +++
>>> 1 file changed, 3 insertions(+)
>>>
>>> diff --git a/drivers/net/ethernet/rocker/rocker.c 
>>> b/drivers/net/ethernet/rocker/rocker.c
>>> index e5a15a4..d7c31d2 100644
>>> --- a/drivers/net/ethernet/rocker/rocker.c
>>> +++ b/drivers/net/ethernet/rocker/rocker.c
>>> @@ -3769,6 +3769,9 @@ static int rocker_port_bridge_setlink(struct 
>>> net_device *dev,
>>>     struct nlattr *attr;
>>>     int err;
>>>
>>> +    if (flags && !(flags & BRIDGE_FLAGS_SELF))
>>> +        return 0;
>>> +
>> I think that the called should handle this case, not every particular
>> driver. How about to put this into rtnl_bridge_setlink?
>
> The problem is setlink can contain many more attributes than just 
> learning.
> And for most attributes you want to mirror them in hardware.
> Only a few attributes like learning, you want to be able to set them 
> in the kernel driver
> differently than in hardware.
>
> We have previously discussed encoding hw/sw in the upper bits of 
> bridge port attributes.
> I was trying to avoid that and use the existing master/self to achieve 
> the same.
>
> I will repost alternatives if I can think of something.
Just adding more clarification to my previous comment: I have not 
confirmed if learning in rocker is really broken.
My patch comment specifically says that the sequence of commands listed 
may turn off learning in rocker hardware unintentionally.